Ticket #257 (closed defect: wontfix)

Opened 12 years ago

Last modified 11 years ago

Consider bumping priority of openafs-modules metapackages from extra to optional

Reported by: mitchb Owned by:
Priority: normal Milestone: Summer 2010 (Lucid Deploy)
Component: -- Keywords:
Cc: Fixed in version:
Upstream bug:

Description

Despite having openafs-modules-foo metapackages installed,
machines that don't update via debathena-auto-update (i.e
any machine below the new debathena-workstation) can take
a new kernel before the new AFS modules are ready. Sometimes
apt[itude] will choose to remove the AFS metapackage instead
of holding back the kernel.

Greg says that the autoupdate infrastructure avoids the
problem by aborting any update where the proposed actions
include removal of important debathena metapackages.

Tim says that increasing the priority of the metapackage
will make apt less likely to prefer its removal.

dkms support exists in Jaunty, and ticket #243 is about
figuring out how to use it, but it sounds like this may
be very unlikely to end up in Hardy and Intrepid, so we're
still stuck with an issue for many machines. Evan requested
this ticket so that we can first get a sense of whether
bumping the priority will actually work.

Some background e-mails from a debathena@ thread below:

*
To: debathena@…
Subject: How does the kernel/openafs version sync thing work again?
Date: Mon, 04 May 2009 21:30:16 -0400
From: Mitchell E Berger <mitchb@…>

This afternoon, I tried to take updates on a machine I maintain,
only to find that it wanted to upgrade the kernel and punt the
openafs metapackages. I was pretty sure we had something in
place to avoid upgrading the kernel until the new modules were
ready, but I didn't recall the details, so I asked Evan to refresh
me on it. After briefly looking at the machine with me, he
concluded that the machine's setup looked right and perhaps something
is wrong with the infrastructure that's supposed to avoid this
problem. So, he suggested I send mail in the hopes that Greg
or someone else will know what's amiss.

When he initially saw the changes that apt-get and aptitude were
proposing, Evan asked if this machine had not been updated in a
while. In fact, it's updated pretty much daily, via 'apt-get dist-upgrade'.

Any ideas?

Thanks,
Mitch

Vital stats:
============
# athinfo localhost version
debathena-login on Ubuntu 8.04.2

# uname -a
Linux 2.6.24-23-xen #1 SMP Wed Apr 1 23:47:10 UTC 2009 x86_64 GNU/Linux
(Note: This machine generally lives as a ParaVM under the -xen kernel, but
it also has the -generic kernel installed)

==========================================================================
# apt-get dist-upgrade
Reading package lists... Done
Building dependency tree
Reading state information... Done
Calculating upgrade... Done
The following packages will be REMOVED:

openafs-modules-generic openafs-modules-xen

The following NEW packages will be installed:

linux-image-2.6.24-24-generic linux-image-2.6.24-24-xen linux-ubuntu-modules-2

.6.24-24-generic linux-ubuntu-modules-2.6.24-24-xen
The following packages have been kept back:

debathena-alpine-config

The following packages will be upgraded:

libwmf0.2-7 linux-image-generic linux-image-xen linux-libc-dev

4 upgraded, 4 newly installed, 2 to remove and 1 not upgraded.
Need to get 47.5MB of archives.
After this operation, 189MB of additional disk space will be used.
===========================================================================

===========================================================================
# aptitude dist-upgrade
Reading package lists... Done
Building dependency tree
Reading state information... Done
Reading extended state information
Initializing package states... Done
Building tag database... Done
The following packages are BROKEN:

debathena-alpine-config openafs-modules-generic openafs-modules-xen

The following packages are unused and will be REMOVED:

alpine debootstrap

The following NEW packages will be installed:

linux-image-2.6.24-24-generic linux-image-2.6.24-24-xen linux-ubuntu-modules-2

.6.24-24-generic linux-ubuntu-modules-2.6.24-24-xen
The following packages will be upgraded:

libwmf0.2-7 linux-image-generic linux-image-xen linux-libc-dev

5 packages upgraded, 4 newly installed, 2 to remove and 0 not upgraded.
Need to get 47.5MB of archives. After unpacking 182MB will be used.
The following packages have unmet dependencies:

openafs-modules-generic: Depends: linux-image-generic (= 2.6.24.23.25) but 2.6

.24.24.26 is to be installed.

openafs-modules-xen: Depends: linux-image-xen (= 2.6.24.23.25) but 2.6.24.24.2

6 is to be installed.

debathena-alpine-config: Depends: debathena-alpine which is a virtual package.

Resolving dependencies...
The following actions will resolve these dependencies:

Remove the following packages:
openafs-modules-generic
openafs-modules-xen

Downgrade the following packages:
alpine [2.00+dfsg-1~hardy1 (hardy-backports, now) -> 1.0+dfsg-3ubuntu0.1debathen
a1~ubuntu8.04 (hardy)]

Score is 223
=============================================================================

============================================================================
# dpkg -l|grep openafs-
ii openafs-client 1.4.6.dfsg1-2+ubuntu0.1
ii openafs-krb5 1.4.6.dfsg1-2+ubuntu0.1
ii openafs-modules-2.6.24-22-xen 1.4.6.dfsg1-2+2.6.24-22.45
ii openafs-modules-2.6.24-23-generic 1.4.6.dfsg1-2+ubuntu0.1+2.6.24-23
.52
ii openafs-modules-2.6.24-23-xen 1.4.6.dfsg1-2+ubuntu0.1+2.6.24-23
.52
ii openafs-modules-generic 2.6.24.23.25~ubuntu8.04
ii openafs-modules-xen 2.6.24.23.25~ubuntu8.04
============================================================================

============================================================================
# aptitude why openafs-modules-2.6.24-23-xen
i openafs-modules-xen Depends openafs-modules-2.6.24-23-xen
# aptitude why openafs-modules-xen
The package "openafs-modules-xen" is manually installed.
# aptitude why openafs-modules-2.6.24-23-generic
i openafs-modules-generic Depends openafs-modules-2.6.24-23-generic
# aptitude why openafs-modules-generic
The package "openafs-modules-generic" is manually installed.
============================================================================

============================================================================
# dpkg -l|grep linux-image
ii linux-image-2.6.24-22-xen 2.6.24-22.45
ii linux-image-2.6.24-23-generic 2.6.24-23.52
ii linux-image-2.6.24-23-xen 2.6.24-23.52
ii linux-image-generic 2.6.24.23.25
ii linux-image-xen 2.6.24.23.25
============================================================================

*
Subject: Re: How does the kernel/openafs version sync thing work again?
From: Greg Hudson <ghudson@…>
To: Mitchell E Berger <mitchb@…>
Cc: debathena@…
Date: Tue, 05 May 2009 11:27:23 -0400

On Mon, 2009-05-04 at 21:30 -0400, Mitchell E Berger wrote:

Any ideas?

The mechanism really only works in combination with a check like
athena-auto-update's, which aborts the update if it sees aptitude
proposing to remove certain Debathena metapackages.

I don't know by what mechanism apt-get is deciding that updating a
kernel is more important than keeping a manually selected package, and
if there's any way to override that.

*
Date: Tue, 5 May 2009 11:58:50 -0400 (EDT)
From: Tim Abbott <tabbott@…>
To: Greg Hudson <ghudson@…>
cc: Mitchell E Berger <mitchb@…>, debathena@…
Subject: Re: How does the kernel/openafs version sync thing work again?

On Tue, 5 May 2009, Greg Hudson wrote:

On Mon, 2009-05-04 at 21:30 -0400, Mitchell E Berger wrote:

Any ideas?

The mechanism really only works in combination with a check like
athena-auto-update's, which aborts the update if it sees aptitude
proposing to remove certain Debathena metapackages.

I don't know by what mechanism apt-get is deciding that updating a
kernel is more important than keeping a manually selected package, and
if there's any way to override that.

Package priority is one thing that goes into this decision. Our modules
package is priority: extra. If we were to raise that, aptitude would be
more reluctant to remove it.

-Tim Abbott

Change History

comment:1 Changed 12 years ago by jdreed

  • Milestone set to IAP 2010

comment:2 Changed 12 years ago by geofft

So this only will bump the score for aptitude by 2 (from -1 to 1) and for apt-get by 1 (from -2 to -1) per package. Can we set up a test case to see if this actually helps?

comment:3 Changed 11 years ago by broder

  • Status changed from new to closed
  • Resolution set to wontfix

We agreed at release-team that any new work on our openafs support should be in the direction of supporting dkms, not in the direction of new development on our autodebathenified openafs module packages, so I'm WONTFIXing this.

Note: See TracTickets for help on using tickets.